import { KeyLike } from 'jose';
import { Jwt } from './jwt';
import { kbHeader, kbPayload } from './type';
export declare class KBJwt<Header extends kbHeader = kbHeader, Payload extends kbPayload = kbPayload> extends Jwt<Header, Payload> {
    verify(publicKey: Uint8Array | KeyLike): Promise<boolean>;
    static fromKBEncode<Header extends kbHeader = kbHeader, Payload extends kbPayload = kbPayload>(encodedJwt: string): KBJwt<Header, Payload>;
}
