"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.KBJwt = void 0;
const error_1 = require("./error");
const jwt_1 = require("./jwt");
class KBJwt extends jwt_1.Jwt {
    verify(publicKey) {
        const _super = Object.create(null, {
            verify: { get: () => super.verify }
        });
        var _a, _b, _c, _d, _e;
        return __awaiter(this, void 0, void 0, function* () {
            if (!((_a = this.header) === null || _a === void 0 ? void 0 : _a.alg) ||
                !this.header.typ ||
                !((_b = this.payload) === null || _b === void 0 ? void 0 : _b.iat) ||
                !((_c = this.payload) === null || _c === void 0 ? void 0 : _c.aud) ||
                !((_d = this.payload) === null || _d === void 0 ? void 0 : _d.nonce) ||
                !((_e = this.payload) === null || _e === void 0 ? void 0 : _e._sd_hash)) {
                throw new error_1.SDJWTException('Invalid Key Binding Jwt');
            }
            return yield _super.verify.call(this, publicKey);
        });
    }
    static fromKBEncode(encodedJwt) {
        const { header, payload, signature } = jwt_1.Jwt.decodeJWT(encodedJwt);
        const jwt = new KBJwt({
            header,
            payload,
            signature,
        });
        return jwt;
    }
}
exports.KBJwt = KBJwt;
